QuickCheck-2.15.0.1: Automatic testing of Haskell programs

Safe Haskell | Trustworthy
Language | Haskell2010

Test.QuickCheck.Modifiers

Contents

- Type-level modifiers for changing generator behavior

Description

Modifiers for test data.

These types do things such as restricting the kind of test data that can be generated. They can be pattern-matched on in properties as a stylistic alternative to using explicit quantification.

Note: the contents of this module are re-exported by Test.QuickCheck. You do not need to import it directly.

Examples:

    -- Functions cannot be shown (but see Test.QuickCheck.Function)
    prop_TakeDropWhile (Blind p) (xs :: [A]) =
      takeWhile p xs ++ dropWhile p xs == xs

    prop_TakeDrop (NonNegative n) (xs :: [A]) =
      take n xs ++ drop n xs == xs

    -- cycle does not work for empty lists
    prop_Cycle (NonNegative n) (NonEmpty (xs :: [A])) =
      take n (cycle xs) == take n (xs ++ cycle xs)

    -- Instead of forAll orderedList
    prop_Sort (Ordered (xs :: [OrdA])) =
      sort xs == xs

Synopsis

- newtype Blind a = Blind {
  - getBlind :: a
  }
- newtype Fixed a = Fixed {
  - getFixed :: a
  }
- newtype OrderedList a = Ordered {
  - getOrdered :: [a]
  }
- newtype NonEmptyList a = NonEmpty {
  - getNonEmpty :: [a]
  }
- data InfiniteList a = InfiniteList {
  - getInfiniteList :: [a]
  - infiniteListInternalData :: InfiniteListInternalData a
  }
- newtype SortedList a = Sorted {
  - getSorted :: [a]
  }
- newtype Positive a = Positive {
  - getPositive :: a
  }
- newtype Negative a = Negative {
  - getNegative :: a
  }
- newtype NonZero a = NonZero {
  - getNonZero :: a
  }
- newtype NonNegative a = NonNegative {
  - getNonNegative :: a
  }
- newtype NonPositive a = NonPositive {
  - getNonPositive :: a
  }
- newtype Large a = Large {
  - getLarge :: a
  }
- newtype Small a = Small {
  - getSmall :: a
  }
- data Smart a = Smart Int a
- newtype Shrink2 a = Shrink2 {
  - getShrink2 :: a
  }
- data Shrinking s a = Shrinking s a
- class ShrinkState s a where
  - shrinkInit :: a -> s
  - shrinkState :: a -> s -> [(a, s)]
- newtype ASCIIString = ASCIIString {
  - getASCIIString :: String
  }
- newtype UnicodeString = UnicodeString {
  - getUnicodeString :: String
  }
- newtype PrintableString = PrintableString {
  - getPrintableString :: String
  }

## Type-level modifiers for changing generator behavior

newtype Blind a Source #

`Blind x`: as x, but x does not have to be in the `Show` class.

Constructors

Blind |

Fields

- getBlind :: a

#### Instances

Instances details

Functor Blind Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods fmap :: (a -> b) -> Blind a -> Blind b Source # (<$) :: a -> Blind b -> Blind a Source #
Arbitrary a => Arbitrary (Blind a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods arbitrary :: Gen (Blind a) Source # shrink :: Blind a -> [Blind a] Source #
Enum a => Enum (Blind a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

succ :: Blind a -> Blind a Source #

pred :: Blind a -> Blind a Source #

toEnum :: Int -> Blind a Source #

fromEnum :: Blind a -> Int Source #

enumFrom :: Blind a -> [Blind a] Source #

enumFromThen :: Blind a -> Blind a -> [Blind a] Source #

enumFromTo :: Blind a -> Blind a -> [Blind a] Source #

enumFromThenTo :: Blind a -> Blind a -> Blind a -> [Blind a] Source #

Num a => Num (Blind a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (+) :: Blind a -> Blind a -> Blind a Source # (-) :: Blind a -> Blind a -> Blind a Source # (*) :: Blind a -> Blind a -> Blind a Source # negate :: Blind a -> Blind a Source # abs :: Blind a -> Blind a Source # signum :: Blind a -> Blind a Source # fromInteger :: Integer -> Blind a Source #
Integral a => Integral (Blind a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

quot :: Blind a -> Blind a -> Blind a Source #

rem :: Blind a -> Blind a -> Blind a Source #

div :: Blind a -> Blind a -> Blind a Source #

mod :: Blind a -> Blind a -> Blind a Source #

quotRem :: Blind a -> Blind a -> (Blind a, Blind a) Source #

divMod :: Blind a -> Blind a -> (Blind a, Blind a) Source #

toInteger :: Blind a -> Integer Source #

Real a => Real (Blind a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods toRational :: Blind a -> Rational Source #
Show (Blind a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods showsPrec :: Int -> Blind a -> ShowS Source # show :: Blind a -> String Source # showList :: [Blind a] -> ShowS Source #
Eq a => Eq (Blind a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (==) :: Blind a -> Blind a -> Bool Source # (/=) :: Blind a -> Blind a -> Bool Source #
Ord a => Ord (Blind a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods compare :: Blind a -> Blind a -> Ordering Source # (<) :: Blind a -> Blind a -> Bool Source # (<=) :: Blind a -> Blind a -> Bool Source # (>) :: Blind a -> Blind a -> Bool Source # (>=) :: Blind a -> Blind a -> Bool Source # max :: Blind a -> Blind a -> Blind a Source # min :: Blind a -> Blind a -> Blind a Source #

newtype Fixed a Source #

`Fixed x`: as x, but will not be shrunk.

Constructors

Fixed |

Fields

- getFixed :: a

#### Instances

Instances details

Functor Fixed Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods fmap :: (a -> b) -> Fixed a -> Fixed b Source # (<$) :: a -> Fixed b -> Fixed a Source #
Arbitrary a => Arbitrary (Fixed a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods arbitrary :: Gen (Fixed a) Source # shrink :: Fixed a -> [Fixed a] Source #
Enum a => Enum (Fixed a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

succ :: Fixed a -> Fixed a Source #

pred :: Fixed a -> Fixed a Source #

toEnum :: Int -> Fixed a Source #

fromEnum :: Fixed a -> Int Source #

enumFrom :: Fixed a -> [Fixed a] Source #

enumFromThen :: Fixed a -> Fixed a -> [Fixed a] Source #

enumFromTo :: Fixed a -> Fixed a -> [Fixed a] Source #

enumFromThenTo :: Fixed a -> Fixed a -> Fixed a -> [Fixed a] Source #

Num a => Num (Fixed a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (+) :: Fixed a -> Fixed a -> Fixed a Source # (-) :: Fixed a -> Fixed a -> Fixed a Source # (*) :: Fixed a -> Fixed a -> Fixed a Source # negate :: Fixed a -> Fixed a Source # abs :: Fixed a -> Fixed a Source # signum :: Fixed a -> Fixed a Source # fromInteger :: Integer -> Fixed a Source #
Read a => Read (Fixed a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods readsPrec :: Int -> ReadS (Fixed a) Source # readList :: ReadS [Fixed a] Source # readPrec :: ReadPrec (Fixed a) Source # readListPrec :: ReadPrec [Fixed a] Source #
Integral a => Integral (Fixed a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

quot :: Fixed a -> Fixed a -> Fixed a Source #

rem :: Fixed a -> Fixed a -> Fixed a Source #

div :: Fixed a -> Fixed a -> Fixed a Source #

mod :: Fixed a -> Fixed a -> Fixed a Source #

quotRem :: Fixed a -> Fixed a -> (Fixed a, Fixed a) Source #

divMod :: Fixed a -> Fixed a -> (Fixed a, Fixed a) Source #

toInteger :: Fixed a -> Integer Source #

Real a => Real (Fixed a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods toRational :: Fixed a -> Rational Source #
Show a => Show (Fixed a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods showsPrec :: Int -> Fixed a -> ShowS Source # show :: Fixed a -> String Source # showList :: [Fixed a] -> ShowS Source #
Eq a => Eq (Fixed a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (==) :: Fixed a -> Fixed a -> Bool Source # (/=) :: Fixed a -> Fixed a -> Bool Source #
Ord a => Ord (Fixed a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods compare :: Fixed a -> Fixed a -> Ordering Source # (<) :: Fixed a -> Fixed a -> Bool Source # (<=) :: Fixed a -> Fixed a -> Bool Source # (>) :: Fixed a -> Fixed a -> Bool Source # (>=) :: Fixed a -> Fixed a -> Bool Source # max :: Fixed a -> Fixed a -> Fixed a Source # min :: Fixed a -> Fixed a -> Fixed a Source #

newtype OrderedList a Source #

`Ordered xs`: guarantees that xs is ordered.

Constructors

Ordered |

Fields

- getOrdered :: [a]

#### Instances

Instances details

Functor OrderedList Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods fmap :: (a -> b) -> OrderedList a -> OrderedList b Source # (<$) :: a -> OrderedList b -> OrderedList a Source #
(Ord a, Arbitrary a) => Arbitrary (OrderedList a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods arbitrary :: Gen (OrderedList a) Source # shrink :: OrderedList a -> [OrderedList a] Source #
Read a => Read (OrderedList a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods readsPrec :: Int -> ReadS (OrderedList a) Source # readList :: ReadS [OrderedList a] Source # readPrec :: ReadPrec (OrderedList a) Source # readListPrec :: ReadPrec [OrderedList a] Source #
Show a => Show (OrderedList a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods showsPrec :: Int -> OrderedList a -> ShowS Source # show :: OrderedList a -> String Source # showList :: [OrderedList a] -> ShowS Source #
Eq a => Eq (OrderedList a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (==) :: OrderedList a -> OrderedList a -> Bool Source # (/=) :: OrderedList a -> OrderedList a -> Bool Source #
Ord a => Ord (OrderedList a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

compare :: OrderedList a -> OrderedList a -> Ordering Source #

(<) :: OrderedList a -> OrderedList a -> Bool Source #

(<=) :: OrderedList a -> OrderedList a -> Bool Source #

(>) :: OrderedList a -> OrderedList a -> Bool Source #

(>=) :: OrderedList a -> OrderedList a -> Bool Source #

max :: OrderedList a -> OrderedList a -> OrderedList a Source #

min :: OrderedList a -> OrderedList a -> OrderedList a Source #

newtype NonEmptyList a Source #

`NonEmpty xs`: guarantees that xs is non-empty.

Constructors

NonEmpty |

Fields

- getNonEmpty :: [a]

#### Instances

Instances details

Functor NonEmptyList Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods fmap :: (a -> b) -> NonEmptyList a -> NonEmptyList b Source # (<$) :: a -> NonEmptyList b -> NonEmptyList a Source #
Arbitrary a => Arbitrary (NonEmptyList a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods arbitrary :: Gen (NonEmptyList a) Source # shrink :: NonEmptyList a -> [NonEmptyList a] Source #
Read a => Read (NonEmptyList a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods readsPrec :: Int -> ReadS (NonEmptyList a) Source # readList :: ReadS [NonEmptyList a] Source # readPrec :: ReadPrec (NonEmptyList a) Source # readListPrec :: ReadPrec [NonEmptyList a] Source #
Show a => Show (NonEmptyList a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods showsPrec :: Int -> NonEmptyList a -> ShowS Source # show :: NonEmptyList a -> String Source # showList :: [NonEmptyList a] -> ShowS Source #
Eq a => Eq (NonEmptyList a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (==) :: NonEmptyList a -> NonEmptyList a -> Bool Source # (/=) :: NonEmptyList a -> NonEmptyList a -> Bool Source #
Ord a => Ord (NonEmptyList a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

compare :: NonEmptyList a -> NonEmptyList a -> Ordering Source #

(<) :: NonEmptyList a -> NonEmptyList a -> Bool Source #

(<=) :: NonEmptyList a -> NonEmptyList a -> Bool Source #

(>) :: NonEmptyList a -> NonEmptyList a -> Bool Source #

(>=) :: NonEmptyList a -> NonEmptyList a -> Bool Source #

max :: NonEmptyList a -> NonEmptyList a -> NonEmptyList a Source #

min :: NonEmptyList a -> NonEmptyList a -> NonEmptyList a Source #

data InfiniteList a Source #

`InfiniteList xs _`: guarantees that xs is an infinite list. When a counterexample is found, only prints the prefix of xs that was used by the program.

Here is a contrived example property:

    prop_take_10 :: InfiniteList Char -> Bool
    prop_take_10 (InfiniteList xs _) =
      or [ x == 'a' | x <- take 10 xs ]

In the following counterexample, the list must start with `"bbbbbbbbbb"` but the remaining (infinite) part can contain anything:

    >>> quickCheck prop_take_10
    *** Failed! Falsified (after 1 test and 14 shrinks):
    "bbbbbbbbbb" ++ ...

Constructors

InfiniteList |

Fields

- getInfiniteList :: [a]
- infiniteListInternalData :: InfiniteListInternalData a

#### Instances

Instances details

Arbitrary a => Arbitrary (InfiniteList a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods arbitrary :: Gen (InfiniteList a) Source # shrink :: InfiniteList a -> [InfiniteList a] Source #
Show a => Show (InfiniteList a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods showsPrec :: Int -> InfiniteList a -> ShowS Source # show :: InfiniteList a -> String Source # showList :: [InfiniteList a] -> ShowS Source #

newtype SortedList a Source #

`Sorted xs`: guarantees that xs is sorted.

Constructors

Sorted |

Fields

- getSorted :: [a]

#### Instances

Instances details

Functor SortedList Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods fmap :: (a -> b) -> SortedList a -> SortedList b Source # (<$) :: a -> SortedList b -> SortedList a Source #
(Arbitrary a, Ord a) => Arbitrary (SortedList a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods arbitrary :: Gen (SortedList a) Source # shrink :: SortedList a -> [SortedList a] Source #
Read a => Read (SortedList a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods readsPrec :: Int -> ReadS (SortedList a) Source # readList :: ReadS [SortedList a] Source # readPrec :: ReadPrec (SortedList a) Source # readListPrec :: ReadPrec [SortedList a] Source #
Show a => Show (SortedList a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods showsPrec :: Int -> SortedList a -> ShowS Source # show :: SortedList a -> String Source # showList :: [SortedList a] -> ShowS Source #
Eq a => Eq (SortedList a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (==) :: SortedList a -> SortedList a -> Bool Source # (/=) :: SortedList a -> SortedList a -> Bool Source #
Ord a => Ord (SortedList a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

compare :: SortedList a -> SortedList a -> Ordering Source #

(<) :: SortedList a -> SortedList a -> Bool Source #

(<=) :: SortedList a -> SortedList a -> Bool Source #

(>) :: SortedList a -> SortedList a -> Bool Source #

(>=) :: SortedList a -> SortedList a -> Bool Source #

max :: SortedList a -> SortedList a -> SortedList a Source #

min :: SortedList a -> SortedList a -> SortedList a Source #

newtype Positive a Source #

`Positive x`: guarantees that `x > 0`.

Constructors

Positive |

Fields

- getPositive :: a

#### Instances

Instances details

Functor Positive Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods fmap :: (a -> b) -> Positive a -> Positive b Source # (<$) :: a -> Positive b -> Positive a Source #
(Num a, Ord a, Arbitrary a) => Arbitrary (Positive a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods arbitrary :: Gen (Positive a) Source # shrink :: Positive a -> [Positive a] Source #
Enum a => Enum (Positive a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

succ :: Positive a -> Positive a Source #

pred :: Positive a -> Positive a Source #

toEnum :: Int -> Positive a Source #

fromEnum :: Positive a -> Int Source #

enumFrom :: Positive a -> [Positive a] Source #

enumFromThen :: Positive a -> Positive a -> [Positive a] Source #

enumFromTo :: Positive a -> Positive a -> [Positive a] Source #

enumFromThenTo :: Positive a -> Positive a -> Positive a -> [Positive a] Source #

Read a => Read (Positive a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods readsPrec :: Int -> ReadS (Positive a) Source # readList :: ReadS [Positive a] Source # readPrec :: ReadPrec (Positive a) Source # readListPrec :: ReadPrec [Positive a] Source #
Show a => Show (Positive a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods showsPrec :: Int -> Positive a -> ShowS Source # show :: Positive a -> String Source # showList :: [Positive a] -> ShowS Source #
Eq a => Eq (Positive a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (==) :: Positive a -> Positive a -> Bool Source # (/=) :: Positive a -> Positive a -> Bool Source #
Ord a => Ord (Positive a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

compare :: Positive a -> Positive a -> Ordering Source #

(<) :: Positive a -> Positive a -> Bool Source #

(<=) :: Positive a -> Positive a -> Bool Source #

(>) :: Positive a -> Positive a -> Bool Source #

(>=) :: Positive a -> Positive a -> Bool Source #

max :: Positive a -> Positive a -> Positive a Source #

min :: Positive a -> Positive a -> Positive a Source #

newtype Negative a Source #

`Negative x`: guarantees that `x < 0`.

Constructors

Negative |

Fields

- getNegative :: a

#### Instances

Instances details

Functor Negative Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods fmap :: (a -> b) -> Negative a -> Negative b Source # (<$) :: a -> Negative b -> Negative a Source #
(Num a, Ord a, Arbitrary a) => Arbitrary (Negative a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods arbitrary :: Gen (Negative a) Source # shrink :: Negative a -> [Negative a] Source #
Enum a => Enum (Negative a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

succ :: Negative a -> Negative a Source #

pred :: Negative a -> Negative a Source #

toEnum :: Int -> Negative a Source #

fromEnum :: Negative a -> Int Source #

enumFrom :: Negative a -> [Negative a] Source #

enumFromThen :: Negative a -> Negative a -> [Negative a] Source #

enumFromTo :: Negative a -> Negative a -> [Negative a] Source #

enumFromThenTo :: Negative a -> Negative a -> Negative a -> [Negative a] Source #

Read a => Read (Negative a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods readsPrec :: Int -> ReadS (Negative a) Source # readList :: ReadS [Negative a] Source # readPrec :: ReadPrec (Negative a) Source # readListPrec :: ReadPrec [Negative a] Source #
Show a => Show (Negative a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods showsPrec :: Int -> Negative a -> ShowS Source # show :: Negative a -> String Source # showList :: [Negative a] -> ShowS Source #
Eq a => Eq (Negative a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (==) :: Negative a -> Negative a -> Bool Source # (/=) :: Negative a -> Negative a -> Bool Source #
Ord a => Ord (Negative a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

compare :: Negative a -> Negative a -> Ordering Source #

(<) :: Negative a -> Negative a -> Bool Source #

(<=) :: Negative a -> Negative a -> Bool Source #

(>) :: Negative a -> Negative a -> Bool Source #

(>=) :: Negative a -> Negative a -> Bool Source #

max :: Negative a -> Negative a -> Negative a Source #

min :: Negative a -> Negative a -> Negative a Source #

newtype NonZero a Source #

`NonZero x`: guarantees that `x /= 0`.

Constructors

NonZero |

Fields

- getNonZero :: a

#### Instances

Instances details

Functor NonZero Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods fmap :: (a -> b) -> NonZero a -> NonZero b Source # (<$) :: a -> NonZero b -> NonZero a Source #
(Num a, Eq a, Arbitrary a) => Arbitrary (NonZero a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods arbitrary :: Gen (NonZero a) Source # shrink :: NonZero a -> [NonZero a] Source #
Enum a => Enum (NonZero a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

succ :: NonZero a -> NonZero a Source #

pred :: NonZero a -> NonZero a Source #

toEnum :: Int -> NonZero a Source #

fromEnum :: NonZero a -> Int Source #

enumFrom :: NonZero a -> [NonZero a] Source #

enumFromThen :: NonZero a -> NonZero a -> [NonZero a] Source #

enumFromTo :: NonZero a -> NonZero a -> [NonZero a] Source #

enumFromThenTo :: NonZero a -> NonZero a -> NonZero a -> [NonZero a] Source #

Read a => Read (NonZero a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods readsPrec :: Int -> ReadS (NonZero a) Source # readList :: ReadS [NonZero a] Source # readPrec :: ReadPrec (NonZero a) Source # readListPrec :: ReadPrec [NonZero a] Source #
Show a => Show (NonZero a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods showsPrec :: Int -> NonZero a -> ShowS Source # show :: NonZero a -> String Source # showList :: [NonZero a] -> ShowS Source #
Eq a => Eq (NonZero a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (==) :: NonZero a -> NonZero a -> Bool Source # (/=) :: NonZero a -> NonZero a -> Bool Source #
Ord a => Ord (NonZero a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

compare :: NonZero a -> NonZero a -> Ordering Source #

(<) :: NonZero a -> NonZero a -> Bool Source #

(<=) :: NonZero a -> NonZero a -> Bool Source #

(>) :: NonZero a -> NonZero a -> Bool Source #

(>=) :: NonZero a -> NonZero a -> Bool Source #

max :: NonZero a -> NonZero a -> NonZero a Source #

min :: NonZero a -> NonZero a -> NonZero a Source #

newtype NonNegative a Source #

`NonNegative x`: guarantees that `x >= 0`.

Constructors

NonNegative |

Fields

- getNonNegative :: a

#### Instances

Instances details

Functor NonNegative Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods fmap :: (a -> b) -> NonNegative a -> NonNegative b Source # (<$) :: a -> NonNegative b -> NonNegative a Source #
(Num a, Ord a, Arbitrary a) => Arbitrary (NonNegative a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods arbitrary :: Gen (NonNegative a) Source # shrink :: NonNegative a -> [NonNegative a] Source #
Enum a => Enum (NonNegative a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

succ :: NonNegative a -> NonNegative a Source #

pred :: NonNegative a -> NonNegative a Source #

toEnum :: Int -> NonNegative a Source #

fromEnum :: NonNegative a -> Int Source #

enumFrom :: NonNegative a -> [NonNegative a] Source #

enumFromThen :: NonNegative a -> NonNegative a -> [NonNegative a] Source #

enumFromTo :: NonNegative a -> NonNegative a -> [NonNegative a] Source #

enumFromThenTo :: NonNegative a -> NonNegative a -> NonNegative a -> [NonNegative a] Source #

Read a => Read (NonNegative a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods readsPrec :: Int -> ReadS (NonNegative a) Source # readList :: ReadS [NonNegative a] Source # readPrec :: ReadPrec (NonNegative a) Source # readListPrec :: ReadPrec [NonNegative a] Source #
Show a => Show (NonNegative a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods showsPrec :: Int -> NonNegative a -> ShowS Source # show :: NonNegative a -> String Source # showList :: [NonNegative a] -> ShowS Source #
Eq a => Eq (NonNegative a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (==) :: NonNegative a -> NonNegative a -> Bool Source # (/=) :: NonNegative a -> NonNegative a -> Bool Source #
Ord a => Ord (NonNegative a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

compare :: NonNegative a -> NonNegative a -> Ordering Source #

(<) :: NonNegative a -> NonNegative a -> Bool Source #

(<=) :: NonNegative a -> NonNegative a -> Bool Source #

(>) :: NonNegative a -> NonNegative a -> Bool Source #

(>=) :: NonNegative a -> NonNegative a -> Bool Source #

max :: NonNegative a -> NonNegative a -> NonNegative a Source #

min :: NonNegative a -> NonNegative a -> NonNegative a Source #

newtype NonPositive a Source #

`NonPositive x`: guarantees that `x <= 0`.

Constructors

NonPositive |

Fields

- getNonPositive :: a

#### Instances

Instances details

Functor NonPositive Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods fmap :: (a -> b) -> NonPositive a -> NonPositive b Source # (<$) :: a -> NonPositive b -> NonPositive a Source #
(Num a, Ord a, Arbitrary a) => Arbitrary (NonPositive a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods arbitrary :: Gen (NonPositive a) Source # shrink :: NonPositive a -> [NonPositive a] Source #
Enum a => Enum (NonPositive a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

succ :: NonPositive a -> NonPositive a Source #

pred :: NonPositive a -> NonPositive a Source #

toEnum :: Int -> NonPositive a Source #

fromEnum :: NonPositive a -> Int Source #

enumFrom :: NonPositive a -> [NonPositive a] Source #

enumFromThen :: NonPositive a -> NonPositive a -> [NonPositive a] Source #

enumFromTo :: NonPositive a -> NonPositive a -> [NonPositive a] Source #

enumFromThenTo :: NonPositive a -> NonPositive a -> NonPositive a -> [NonPositive a] Source #

Read a => Read (NonPositive a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods readsPrec :: Int -> ReadS (NonPositive a) Source # readList :: ReadS [NonPositive a] Source # readPrec :: ReadPrec (NonPositive a) Source # readListPrec :: ReadPrec [NonPositive a] Source #
Show a => Show (NonPositive a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods showsPrec :: Int -> NonPositive a -> ShowS Source # show :: NonPositive a -> String Source # showList :: [NonPositive a] -> ShowS Source #
Eq a => Eq (NonPositive a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (==) :: NonPositive a -> NonPositive a -> Bool Source # (/=) :: NonPositive a -> NonPositive a -> Bool Source #
Ord a => Ord (NonPositive a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

compare :: NonPositive a -> NonPositive a -> Ordering Source #

(<) :: NonPositive a -> NonPositive a -> Bool Source #

(<=) :: NonPositive a -> NonPositive a -> Bool Source #

(>) :: NonPositive a -> NonPositive a -> Bool Source #

(>=) :: NonPositive a -> NonPositive a -> Bool Source #

max :: NonPositive a -> NonPositive a -> NonPositive a Source #

min :: NonPositive a -> NonPositive a -> NonPositive a Source #

newtype Large a Source #

`Large x`: by default, QuickCheck generates `Int`s drawn from a small range. `Large Int` gives you values drawn from the entire range instead.

Constructors

Large |

Fields

- getLarge :: a

#### Instances

Instances details

Functor Large Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods fmap :: (a -> b) -> Large a -> Large b Source # (<$) :: a -> Large b -> Large a Source #
(Integral a, Bounded a) => Arbitrary (Large a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods arbitrary :: Gen (Large a) Source # shrink :: Large a -> [Large a] Source #
Enum a => Enum (Large a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

succ :: Large a -> Large a Source #

pred :: Large a -> Large a Source #

toEnum :: Int -> Large a Source #

fromEnum :: Large a -> Int Source #

enumFrom :: Large a -> [Large a] Source #

enumFromThen :: Large a -> Large a -> [Large a] Source #

enumFromTo :: Large a -> Large a -> [Large a] Source #

enumFromThenTo :: Large a -> Large a -> Large a -> [Large a] Source #

Ix a => Ix (Large a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods range :: (Large a, Large a) -> [Large a] Source # index :: (Large a, Large a) -> Large a -> Int Source # unsafeIndex :: (Large a, Large a) -> Large a -> Int Source # inRange :: (Large a, Large a) -> Large a -> Bool Source # rangeSize :: (Large a, Large a) -> Int Source # unsafeRangeSize :: (Large a, Large a) -> Int Source #
Num a => Num (Large a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (+) :: Large a -> Large a -> Large a Source # (-) :: Large a -> Large a -> Large a Source # (*) :: Large a -> Large a -> Large a Source # negate :: Large a -> Large a Source # abs :: Large a -> Large a Source # signum :: Large a -> Large a Source # fromInteger :: Integer -> Large a Source #
Read a => Read (Large a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods readsPrec :: Int -> ReadS (Large a) Source # readList :: ReadS [Large a] Source # readPrec :: ReadPrec (Large a) Source # readListPrec :: ReadPrec [Large a] Source #
Integral a => Integral (Large a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

quot :: Large a -> Large a -> Large a Source #

rem :: Large a -> Large a -> Large a Source #

div :: Large a -> Large a -> Large a Source #

mod :: Large a -> Large a -> Large a Source #

quotRem :: Large a -> Large a -> (Large a, Large a) Source #

divMod :: Large a -> Large a -> (Large a, Large a) Source #

toInteger :: Large a -> Integer Source #

Real a => Real (Large a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods toRational :: Large a -> Rational Source #
Show a => Show (Large a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods showsPrec :: Int -> Large a -> ShowS Source # show :: Large a -> String Source # showList :: [Large a] -> ShowS Source #
Eq a => Eq (Large a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (==) :: Large a -> Large a -> Bool Source # (/=) :: Large a -> Large a -> Bool Source #
Ord a => Ord (Large a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods compare :: Large a -> Large a -> Ordering Source # (<) :: Large a -> Large a -> Bool Source # (<=) :: Large a -> Large a -> Bool Source # (>) :: Large a -> Large a -> Bool Source # (>=) :: Large a -> Large a -> Bool Source # max :: Large a -> Large a -> Large a Source # min :: Large a -> Large a -> Large a Source #

newtype Small a Source #

`Small x`: generates values of `x` drawn from a small range. The opposite of `Large`.

Constructors

Small |

Fields

- getSmall :: a

#### Instances

Instances details

Functor Small Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods fmap :: (a -> b) -> Small a -> Small b Source # (<$) :: a -> Small b -> Small a Source #
Integral a => Arbitrary (Small a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods arbitrary :: Gen (Small a) Source # shrink :: Small a -> [Small a] Source #
Enum a => Enum (Small a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

succ :: Small a -> Small a Source #

pred :: Small a -> Small a Source #

toEnum :: Int -> Small a Source #

fromEnum :: Small a -> Int Source #

enumFrom :: Small a -> [Small a] Source #

enumFromThen :: Small a -> Small a -> [Small a] Source #

enumFromTo :: Small a -> Small a -> [Small a] Source #

enumFromThenTo :: Small a -> Small a -> Small a -> [Small a] Source #

Ix a => Ix (Small a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods range :: (Small a, Small a) -> [Small a] Source # index :: (Small a, Small a) -> Small a -> Int Source # unsafeIndex :: (Small a, Small a) -> Small a -> Int Source # inRange :: (Small a, Small a) -> Small a -> Bool Source # rangeSize :: (Small a, Small a) -> Int Source # unsafeRangeSize :: (Small a, Small a) -> Int Source #
Num a => Num (Small a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (+) :: Small a -> Small a -> Small a Source # (-) :: Small a -> Small a -> Small a Source # (*) :: Small a -> Small a -> Small a Source # negate :: Small a -> Small a Source # abs :: Small a -> Small a Source # signum :: Small a -> Small a Source # fromInteger :: Integer -> Small a Source #
Read a => Read (Small a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods readsPrec :: Int -> ReadS (Small a) Source # readList :: ReadS [Small a] Source # readPrec :: ReadPrec (Small a) Source # readListPrec :: ReadPrec [Small a] Source #
Integral a => Integral (Small a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

quot :: Small a -> Small a -> Small a Source #

rem :: Small a -> Small a -> Small a Source #

div :: Small a -> Small a -> Small a Source #

mod :: Small a -> Small a -> Small a Source #

quotRem :: Small a -> Small a -> (Small a, Small a) Source #

divMod :: Small a -> Small a -> (Small a, Small a) Source #

toInteger :: Small a -> Integer Source #

Real a => Real (Small a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods toRational :: Small a -> Rational Source #
Show a => Show (Small a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods showsPrec :: Int -> Small a -> ShowS Source # show :: Small a -> String Source # showList :: [Small a] -> ShowS Source #
Eq a => Eq (Small a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (==) :: Small a -> Small a -> Bool Source # (/=) :: Small a -> Small a -> Bool Source #
Ord a => Ord (Small a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods compare :: Small a -> Small a -> Ordering Source # (<) :: Small a -> Small a -> Bool Source # (<=) :: Small a -> Small a -> Bool Source # (>) :: Small a -> Small a -> Bool Source # (>=) :: Small a -> Small a -> Bool Source # max :: Small a -> Small a -> Small a Source # min :: Small a -> Small a -> Small a Source #

data Smart a Source #

`Smart _ x`: tries a different order when shrinking.

Constructors

Smart Int a |

#### Instances

Instances details

Functor Smart Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods fmap :: (a -> b) -> Smart a -> Smart b Source # (<$) :: a -> Smart b -> Smart a Source #
Arbitrary a => Arbitrary (Smart a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods arbitrary :: Gen (Smart a) Source # shrink :: Smart a -> [Smart a] Source #
Show a => Show (Smart a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods showsPrec :: Int -> Smart a -> ShowS Source # show :: Smart a -> String Source # showList :: [Smart a] -> ShowS Source #

newtype Shrink2 a Source #

`Shrink2 x`: allows 2 shrinking steps at the same time when shrinking x

Constructors

Shrink2 |

Fields

- getShrink2 :: a

#### Instances

Instances details

Functor Shrink2 Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods fmap :: (a -> b) -> Shrink2 a -> Shrink2 b Source # (<$) :: a -> Shrink2 b -> Shrink2 a Source #
Arbitrary a => Arbitrary (Shrink2 a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods arbitrary :: Gen (Shrink2 a) Source # shrink :: Shrink2 a -> [Shrink2 a] Source #
Enum a => Enum (Shrink2 a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

succ :: Shrink2 a -> Shrink2 a Source #

pred :: Shrink2 a -> Shrink2 a Source #

toEnum :: Int -> Shrink2 a Source #

fromEnum :: Shrink2 a -> Int Source #

enumFrom :: Shrink2 a -> [Shrink2 a] Source #

enumFromThen :: Shrink2 a -> Shrink2 a -> [Shrink2 a] Source #

enumFromTo :: Shrink2 a -> Shrink2 a -> [Shrink2 a] Source #

enumFromThenTo :: Shrink2 a -> Shrink2 a -> Shrink2 a -> [Shrink2 a] Source #

Num a => Num (Shrink2 a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (+) :: Shrink2 a -> Shrink2 a -> Shrink2 a Source # (-) :: Shrink2 a -> Shrink2 a -> Shrink2 a Source # (*) :: Shrink2 a -> Shrink2 a -> Shrink2 a Source # negate :: Shrink2 a -> Shrink2 a Source # abs :: Shrink2 a -> Shrink2 a Source # signum :: Shrink2 a -> Shrink2 a Source # fromInteger :: Integer -> Shrink2 a Source #
Read a => Read (Shrink2 a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods readsPrec :: Int -> ReadS (Shrink2 a) Source # readList :: ReadS [Shrink2 a] Source # readPrec :: ReadPrec (Shrink2 a) Source # readListPrec :: ReadPrec [Shrink2 a] Source #
Integral a => Integral (Shrink2 a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

quot :: Shrink2 a -> Shrink2 a -> Shrink2 a Source #

rem :: Shrink2 a -> Shrink2 a -> Shrink2 a Source #

div :: Shrink2 a -> Shrink2 a -> Shrink2 a Source #

mod :: Shrink2 a -> Shrink2 a -> Shrink2 a Source #

quotRem :: Shrink2 a -> Shrink2 a -> (Shrink2 a, Shrink2 a) Source #

divMod :: Shrink2 a -> Shrink2 a -> (Shrink2 a, Shrink2 a) Source #

toInteger :: Shrink2 a -> Integer Source #

Real a => Real (Shrink2 a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods toRational :: Shrink2 a -> Rational Source #
Show a => Show (Shrink2 a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods showsPrec :: Int -> Shrink2 a -> ShowS Source # show :: Shrink2 a -> String Source # showList :: [Shrink2 a] -> ShowS Source #
Eq a => Eq (Shrink2 a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (==) :: Shrink2 a -> Shrink2 a -> Bool Source # (/=) :: Shrink2 a -> Shrink2 a -> Bool Source #
Ord a => Ord (Shrink2 a) Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

compare :: Shrink2 a -> Shrink2 a -> Ordering Source #

(<) :: Shrink2 a -> Shrink2 a -> Bool Source #

(<=) :: Shrink2 a -> Shrink2 a -> Bool Source #

(>) :: Shrink2 a -> Shrink2 a -> Bool Source #

(>=) :: Shrink2 a -> Shrink2 a -> Bool Source #

max :: Shrink2 a -> Shrink2 a -> Shrink2 a Source #

min :: Shrink2 a -> Shrink2 a -> Shrink2 a Source #

data Shrinking s a Source #

`Shrinking _ x`: allows for maintaining a state during shrinking.

Constructors

Shrinking s a |

#### Instances

Instances details

Functor (Shrinking s) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods fmap :: (a -> b) -> Shrinking s a -> Shrinking s b Source # (<$) :: a -> Shrinking s b -> Shrinking s a Source #
(Arbitrary a, ShrinkState s a) => Arbitrary (Shrinking s a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods arbitrary :: Gen (Shrinking s a) Source # shrink :: Shrinking s a -> [Shrinking s a] Source #
Show a => Show (Shrinking s a) Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods showsPrec :: Int -> Shrinking s a -> ShowS Source # show :: Shrinking s a -> String Source # showList :: [Shrinking s a] -> ShowS Source #

class ShrinkState s a where Source #

Methods

shrinkInit :: a -> s Source #

shrinkState :: a -> s -> [(a, s)] Source #

newtype ASCIIString Source #

`ASCIIString`: generates an ASCII string.

Constructors

ASCIIString |

Fields

- getASCIIString :: String

#### Instances

Instances details

Arbitrary ASCIIString Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods arbitrary :: Gen ASCIIString Source # shrink :: ASCIIString -> [ASCIIString] Source #
Read ASCIIString Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods readsPrec :: Int -> ReadS ASCIIString Source # readList :: ReadS [ASCIIString] Source # readPrec :: ReadPrec ASCIIString Source # readListPrec :: ReadPrec [ASCIIString] Source #
Show ASCIIString Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods showsPrec :: Int -> ASCIIString -> ShowS Source # show :: ASCIIString -> String Source # showList :: [ASCIIString] -> ShowS Source #
Eq ASCIIString Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (==) :: ASCIIString -> ASCIIString -> Bool Source # (/=) :: ASCIIString -> ASCIIString -> Bool Source #
Ord ASCIIString Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

compare :: ASCIIString -> ASCIIString -> Ordering Source #

(<) :: ASCIIString -> ASCIIString -> Bool Source #

(<=) :: ASCIIString -> ASCIIString -> Bool Source #

(>) :: ASCIIString -> ASCIIString -> Bool Source #

(>=) :: ASCIIString -> ASCIIString -> Bool Source #

max :: ASCIIString -> ASCIIString -> ASCIIString Source #

min :: ASCIIString -> ASCIIString -> ASCIIString Source #

newtype UnicodeString Source #

`UnicodeString`: generates a unicode String. The string will not contain surrogate pairs.

Constructors

UnicodeString |

Fields

- getUnicodeString :: String

#### Instances

Instances details

Arbitrary UnicodeString Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods arbitrary :: Gen UnicodeString Source # shrink :: UnicodeString -> [UnicodeString] Source #
Read UnicodeString Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods readsPrec :: Int -> ReadS UnicodeString Source # readList :: ReadS [UnicodeString] Source # readPrec :: ReadPrec UnicodeString Source # readListPrec :: ReadPrec [UnicodeString] Source #
Show UnicodeString Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods showsPrec :: Int -> UnicodeString -> ShowS Source # show :: UnicodeString -> String Source # showList :: [UnicodeString] -> ShowS Source #
Eq UnicodeString Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (==) :: UnicodeString -> UnicodeString -> Bool Source # (/=) :: UnicodeString -> UnicodeString -> Bool Source #
Ord UnicodeString Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

compare :: UnicodeString -> UnicodeString -> Ordering Source #

(<) :: UnicodeString -> UnicodeString -> Bool Source #

(<=) :: UnicodeString -> UnicodeString -> Bool Source #

(>) :: UnicodeString -> UnicodeString -> Bool Source #

(>=) :: UnicodeString -> UnicodeString -> Bool Source #

max :: UnicodeString -> UnicodeString -> UnicodeString Source #

min :: UnicodeString -> UnicodeString -> UnicodeString Source #

newtype PrintableString Source #

`PrintableString`: generates a printable unicode String. The string will not contain surrogate pairs.

Constructors

PrintableString |

Fields

- getPrintableString :: String

#### Instances

Instances details

Arbitrary PrintableString Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods arbitrary :: Gen PrintableString Source # shrink :: PrintableString -> [PrintableString] Source #
Read PrintableString Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods readsPrec :: Int -> ReadS PrintableString Source # readList :: ReadS [PrintableString] Source # readPrec :: ReadPrec PrintableString Source # readListPrec :: ReadPrec [PrintableString] Source #
Show PrintableString Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods showsPrec :: Int -> PrintableString -> ShowS Source # show :: PrintableString -> String Source # showList :: [PrintableString] -> ShowS Source #
Eq PrintableString Source # |
Instance details Defined in Test.QuickCheck.Modifiers Methods (==) :: PrintableString -> PrintableString -> Bool Source # (/=) :: PrintableString -> PrintableString -> Bool Source #
Ord PrintableString Source # |

Instance details

Defined in Test.QuickCheck.Modifiers

Methods

compare :: PrintableString -> PrintableString -> Ordering Source #

(<) :: PrintableString -> PrintableString -> Bool Source #

(<=) :: PrintableString -> PrintableString -> Bool Source #

(>) :: PrintableString -> PrintableString -> Bool Source #

(>=) :: PrintableString -> PrintableString -> Bool Source #

max :: PrintableString -> PrintableString -> PrintableString Source #

min :: PrintableString -> PrintableString -> PrintableString Source #